/*--------------------------------------*/
/*	引数取得							*/
/*--------------------------------------*/
function get_url_vars(){
	var vars = new Object, params;
	var temp_params = window.location.search.substring(1).split('&');
	for(var i = 0; i <temp_params.length; i++) {
		params = temp_params[i].split('=');
		if(params[1]){
			vars[params[0]] = decodeURIComponent(params[1]);
		}else{
			vars[params[0]] = '';
		}
	}
	return vars;
}

$(function() {
	//  ユーザ入力受付
	var userEntry = false;
	//  シナリオ
	var comlists = com;
	//  終了フラグ
	var end_flag = false;
	//  既読数
	var kidoku_flag = [];

	/*  リアルタイム時刻表示
	++++++++++++++++++++++++++++++++++++*/
	var clock = function (){
		$('.header .time').text(getNow());
	}

	function getNow() {
		var now = new Date();
		var hour = now.getHours();
		var min = now.getMinutes();
		if(min < 10){ min = '0'+min;}
		var sec = now.getSeconds();

		//出力用
		var s = hour + ":" + min; 
		return s;
	}
	
 // 0.5秒毎にclock()を実行
	var timerID = setInterval(clock,500);
	
	/*  入力状態変更
	++++++++++++++++++++++++++++++++++++*/
	function setUserEntry(flag){
		if(flag){
			$('#user_entry').attr('disabled',false);
			$('#user_submit').attr('disabled',false);
		}else{
			$('#user_entry').attr('disabled',true);
			$('#user_submit').attr('disabled',true);
		}
	}
		
	/*  ユーザ入力受付
	++++++++++++++++++++++++++++++++++++*/
	$('#user_submit').on('click',function(){
		var user_entry = $('#user_entry').val();
		if(user_entry != ''){
			var comment = '<div class="entry user_box last">'
			comment += '<div class="time"><p></p>'+ getNow() +'</div>';
			comment += '<div class="comment"><p class="text">'+ user_entry +'</p></div>';
			comment += '</div>';
			$('.entry').removeClass('last');
			$('.chat_body').append(comment);
			$('#user_entry').val('');
			$(".chat_body").scrollTop( $(".chat_body")[0].scrollHeight );
			
			if(userEntry == false){
				userEntry = true;
				step();
			}
		}	
	});

	/*  待機
	++++++++++++++++++++++++++++++++++++*/
	function wait(sec) {
		var d = $.Deferred();
		setTimeout(function() {
			d.resolve();
		}, sec * 1000);
		return d.promise();
	}
	
	/*  ユーザ入力受付
	++++++++++++++++++++++++++++++++++++*/
	function step(){
		var user_flag = '';
		
		//  ユーザ入力待ち
		if(comlists[0].action == true && userEntry == false){
			//  ユーザ入力を可能にする
			setUserEntry(true);
			$('.user_block').attr('class','user_block');
			$('#user_entry').focus();
		}else{
			//  ユーザ入力無効
			setUserEntry(false);
			$('.user_block').attr('class','user_block active');
			userEntry = false;

			if(!comlists[0].escape){
				//  コメント生成
				var comment = '<div class="entry auto_box last ' + comlists[0].user + '">';
				comment += '<div class="comment">';
				comment += '<p class="name">' + comlists[0].name + '</p>';
				comment += '<p class="text">' + comlists[0].text + '</p>';
				comment += '</div>';
				comment += '<p class="time">'+ getNow() +'</p>';
				comment += '</div>';
				if($.inArray(comlists[0].user, kidoku_flag) < 0){
					kidoku_flag.push(comlists[0].user);
					user_flag = true;
				}else{
					user_flag = false;
				}
			}else{
				//  コメント生成
				var comment = '<div class="escape">';
				comment += '<p class="time">'+ getNow() +'</p>';
				comment += '<p>' + comlists[0].name + 'が退室しました。</p>';
				comment += '</div>';
				// $.inArray(検索文字列, 配列)
				var idx = $.inArray(comlists[0].user, kidoku_flag);
				if(idx >= 0){
					kidoku_flag.splice(idx, 1); 
				}
			}
			//  終了フラグ保持
			end_flag = comlists[0].end;
			
			//  表示
			$.when(
				//  待機
				wait(comlists[0].interval)
			).done(function(){ 
				//  出力
				$('.entry').removeClass('last');
				$('.chat_body').append(comment);
				
				if(!comlists[0].escape){
					//  既読数処理
					$('.user_box .time p').each(function(index, element){
						var count = $(element).children('span');
						if(count.text() && user_flag){
//							count = parseInt(count.text()) + 1;
							count = kidoku_flag.length;
						}else{
							count = kidoku_flag.length;
						}
						$(element).html('既読(<span>'+ count + '</span>)');
					});
				};

				//  先頭のデータ削除
				comlists.shift();
				//  ウィンドウ移動
				$(".chat_body").scrollTop( $(".chat_body")[0].scrollHeight );

				//  終了判定
				if(end_flag){
					//  表示
					$.when(
						//  待機
						wait(10)
					).done(function(){ 
						$('.end').show();
					});
				}else{
					step();
				}
			});
		}
	}

	/*  送信履歴を見る
	++++++++++++++++++++++++++++++++++++*/
	$('.end .close a').on('click',function(){
		$('.end').hide();
	});

	
	//  初期起動
	setUserEntry(false);
	step();
	
	var winHeight = $(window).height();
	var deviceTop = $("#device_top").height();
	//var deviceMiddle = $("#device_middle").height();
	var deviceBottom = $("#device_bottom").height();
	var setHeight = winHeight - deviceTop - deviceBottom;
	if(setHeight > 500){
		//$('#device_middle').height(setHeight);
		//$('.chat_body').height(setHeight - 370);
	}
	$('.end .note').html(end_message);
});
